with Ada.Text_IO;
package body GNAT_Helper is

	procedure Execute (Command : in String; Verbose : in Boolean) is
		function system (Command : not null access constant Character) return Integer;
		pragma Import (C, system, "system");
		Code : Integer;
		C : constant String := Command & Character'Val(0);
		use Ada.Text_IO;
	begin
		if Verbose then
			Put_Line(Command);
		end if;
		Code := system (C(C'First)'Unrestricted_Access);
		if Code = -1 then
			raise Execute_Error with """" & Command & """ could not executed.";
		end if;
		if Code > 0 then
			raise Execute_Error with """" & Command & """ failed.";
		end if;
	end Execute;

	function Extract_Version_Num (Version : String) return Version_Num_String is
		V : String renames Version;
		H : constant String := "GNAT Version: ";
	begin
		if V (V'First .. V'First + H'Length - 1) = H then
			return V (V'First + H'Length .. V'First + H'Length + 4);
		else
			return V (V'First .. V'First + 4);
		end if;
	end Extract_Version_Num;

end GNAT_Helper;
