with Ada.Command_Line;
with Ada.Text_IO;
with GNAT_Helper; use GNAT_Helper;
procedure gnatpsta is

	procedure Usage is
		use Ada.Text_IO;
	begin
		Put_Line("Usage: gnatpsta [switches]");
		New_Line;
		Put_Line("  --help        print this messeages");
		Put_Line("  -v            verbose mode");
		Put_Line("  --version     print version number and exit");
	end Usage;

	Print_Usage : exception;
	Print_Version : exception;
	Invalid_Args : exception;

	Verbose : Boolean := False;
begin
	declare
		use Ada.Command_Line;
	begin
		for I in 1 .. Argument_Count loop
			declare
				Arg : constant String := Ada.Command_Line.Argument(I);
			begin
				if Arg = "-v" then
					Verbose := True;
				elsif Arg = "--help" then
					raise Print_Usage;
				elsif Arg = "--version" then
					raise Print_Version;
				else
					raise Invalid_Args;
				end if;
			end;
		end loop;
	end;
	Execute("cmd /c echo package gnatpsta_dummy is end; > gnatpsta_dummy.ads", Verbose);
	Execute("gcc -c -gnatS gnatpsta_dummy.ads", Verbose);
	Execute("cmd /c del gnatpsta_dummy.*", Verbose);
exception
	when Print_Usage => Usage;
	when Print_Version => Ada.Text_IO.Put_Line(Version);
	when Invalid_Args => Ada.Text_IO.Put_Line(Ada.Text_IO.Current_Error, "Invalid command line argument.");
end gnatpsta;
